#!/usr/bin/env python3

# byterev.py: reverse the bits in all bytes
# 2020-07-19,  ed <irc.rizon.net>,  MIT-licensed


import sys
import struct


def rev(buf):
    ret = b''
    for chi in struct.unpack(b'B'*len(buf), buf):
        cho = 0
        for n in range(8):
            if (chi >> n) & 1:
                cho |= 1 << (7 - n)

        ret += struct.pack(b'B', cho)
    return ret


with open(sys.argv[1], 'rb') as fi:
    with open(sys.argv[2], 'wb') as fo:
        while True:
            buf = fi.read(4096)
            if not buf:
                break

            buf = rev(buf)
            fo.write(buf)


# printf "$(printf '\\x%02x' {0..255})" > all-bytes

